## com.sun.jersey.api.client
Class WebResource

    java.lang.Object
      com.sun.jersey.api.client.filter.Filterable
          com.sun.jersey.api.client.WebResource

All Implemented Interfaces:
  RequestBuilder<WebResource.Builder>, UniformInterface

    public class WebResource

extends Filterable
implements RequestBuilder<WebResource.Builder>, UniformInterface

An encapsulation of a Web resource capable of building requests to send to the Web resource and processing responses returned from the Web resource.

A WebResource instance is obtained from the `Client`.

The Web resource implements the `UniformInterface` to invoke the HTTP method on the Web resource. A client request may be built before invocation on the uniform interface.

Methods to create a request and return a response are thread-safe. Methods that modify filters are not guaranteed to be thread-safe.

Author:
  Paul.Sandoz@Sun.Com
See Also:
  `com.sun.jersey.api.client`

Nested Class Summary
`class` | `WebResource.Builder` The builder for building a `ClientRequest` instance and handling the request using the `UniformInterface`.

Method Summary
`WebResource.Builder` | `accept(MediaType... types)` Add acceptable media types.
`WebResource.Builder` | `accept(java.lang.String... types)` Add acceptable media types.
`WebResource.Builder` | `acceptLanguage(java.util.Locale... locales)` Add acceptable languages
`WebResource.Builder` | `acceptLanguage(java.lang.String... locales)` Add acceptable languages
`WebResource.Builder` | `cookie(Cookie cookie)` Add a cookie to be set.
`void` | `delete()` Invoke the DELETE method with no request entity or response.

`

`<T> T`

`

`delete(java.lang.Class<T> c)`
Invoke the DELETE method with no request entity that returns a response.

`

`<T> T`

`

`delete(java.lang.Class<T> c, java.lang.Object requestEntity)`
Invoke the DELETE method with a request entity that returns a response.

`

`<T> T`

`

`delete(GenericType<T> gt)`
Invoke the DELETE method with a request entity that returns a response.

`

`<T> T`

`

`delete(GenericType<T> gt, java.lang.Object requestEntity)`
Invoke the DELETE method with a request entity that returns a response.

`void` | `delete(java.lang.Object requestEntity)` Invoke the DELETE method with a request entity but no response.
`WebResource.Builder` | `entity(java.lang.Object entity)` Set the request entity.
`WebResource.Builder` | `entity(java.lang.Object entity, MediaType type)` Set the request entity with its media type.
`WebResource.Builder` | `entity(java.lang.Object entity, java.lang.String type)` Set the request entity with its media type.
`boolean` | `equals(java.lang.Object obj)` Compares this resource to the specified object.

`

`<T> T`

`

`get(java.lang.Class<T> c)`
Invoke the GET method.

`

`<T> T`

`

`get(GenericType<T> gt)`
Invoke the GET method.

`UriBuilder` | `getBuilder()` Deprecated.
`java.util.Map<java.lang.String,java.lang.Object>` | `getProperties()` Gets WebResource related properties.
`WebResource.Builder` | `getRequestBuilder()` Get the ClientRequest builder.
`java.net.URI` | `getURI()` Get the URI to the resource.
`UriBuilder` | `getUriBuilder()` Get the URI builder to the resource.
`int` | `hashCode()` Returns a hash code for this `WebResource`.
`ClientResponse` | `head()` Invoke the HEAD method.
`WebResource.Builder` | `header(java.lang.String name, java.lang.Object value)` Add an HTTP header and value.
`void` | `method(java.lang.String method)` Invoke a HTTP method with no request entity or response.

`

`<T> T`

`

`method(java.lang.String method, java.lang.Class<T> c)`
Invoke a HTTP method with no request entity that returns a response.

`

`<T> T`

`

`method(java.lang.String method, java.lang.Class<T> c, java.lang.Object requestEntity)`
Invoke a HTTP method with a request entity that returns a response.

`

`<T> T`

`

`method(java.lang.String method, GenericType<T> gt)`
Invoke a HTTP method with no request entity that returns a response.

`

`<T> T`

`

`method(java.lang.String method, GenericType<T> gt, java.lang.Object requestEntity)`
Invoke a HTTP method with a request entity that returns a response.

`void` | `method(java.lang.String method, java.lang.Object requestEntity)` Invoke a HTTP method with a request entity but no response.

`

`<T> T`

`

`options(java.lang.Class<T> c)`
Invoke the OPTIONS method.

`

`<T> T`

`

`options(GenericType<T> gt)`
Invoke the OPTIONS method.

`WebResource` | `path(java.lang.String path)` Create a new WebResource from this web resource with an additional path added to the URI of this web resource.
`void` | `post()` Invoke the POST method with no request entity or response.

`

`<T> T`

`

`post(java.lang.Class<T> c)`
Invoke the POST method with no request entity that returns a response.

`

`<T> T`

`

`post(java.lang.Class<T> c, java.lang.Object requestEntity)`
Invoke the POST method with a request entity that returns a response.

`

`<T> T`

`

`post(GenericType<T> gt)`
Invoke the POST method with a request entity that returns a response.

`

`<T> T`

`

`post(GenericType<T> gt, java.lang.Object requestEntity)`
Invoke the POST method with a request entity that returns a response.

`void` | `post(java.lang.Object requestEntity)` Invoke the POST method with a request entity but no response.
`void` | `put()` Invoke the PUT method with no request entity or response.

`

`<T> T`

`

`put(java.lang.Class<T> c)`
Invoke the PUT method with no request entity that returns a response.

`

`<T> T`

`

`put(java.lang.Class<T> c, java.lang.Object requestEntity)`
Invoke the PUT method with a request entity that returns a response.

`

`<T> T`

`

`put(GenericType<T> gt)`
Invoke the PUT method with a request entity that returns a response.

`

`<T> T`

`

`put(GenericType<T> gt, java.lang.Object requestEntity)`
Invoke the PUT method with a request entity that returns a response.

`void` | `put(java.lang.Object requestEntity)` Invoke the PUT method with a request entity but no response.
`WebResource` | `queryParam(java.lang.String key, java.lang.String value)` Create a new WebResource from this web resource with an additional query parameter added to the URI of this web resource.
`WebResource` | `queryParams(MultivaluedMap<java.lang.String,java.lang.String> params)` Create a new WebResource from this web resource with additional query parameters added to the URI of this web resource.
`void` | `setProperty(java.lang.String property, java.lang.Object value)` Sets WebResource related property.
`java.lang.String` | `toString()`
`WebResource.Builder` | `type(MediaType type)` Set the media type.
`WebResource.Builder` | `type(java.lang.String type)` Set the media type.
`WebResource` | `uri(java.net.URI uri)` Create a new WebResource from this web resource.

Methods inherited from class com.sun.jersey.api.client.filter.Filterable
`addFilter, getHeadHandler, isFilterPresent, isFilterPreset, removeAllFilters, removeFilter`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### getURI

    public java.net.URI getURI()

  Get the URI to the resource.

  Returns:
    the URI.

### getBuilder

    @Deprecated
    public UriBuilder getBuilder()

  Deprecated.

  Get the URI builder to the resource.

  Returns:
    the URI builder.

### getUriBuilder

    public UriBuilder getUriBuilder()

  Get the URI builder to the resource.

  Returns:
    the URI builder.

### getRequestBuilder

    public WebResource.Builder getRequestBuilder()

  Get the ClientRequest builder.

  Returns:
    the ClientRequest builder.

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    the URI as a String instance

### hashCode

    public int hashCode()

  Returns a hash code for this `WebResource`.

  The hash code is the hash code of URI of this `WebResource`.

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    a hash code for this `WebResource`.

### equals

    public boolean equals(java.lang.Object obj)

  Compares this resource to the specified object.

  The result is true if and only if the argument is not null and is a `WebResource` object whose URI is equal to the URI of this `WebResource`.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `obj` - the object to compare this `WebResource` against.
  Returns:
    true if the `WebResource` are equal; false otherwise.

### head

    public ClientResponse head()
                        throws ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the HEAD method.

  Specified by:
    `head` in interface `UniformInterface`
  Returns:
    the HTTP response.
  Throws:
    `ClientHandlerException` - if the client handler fails to process the request or response.

### options

    public <T> T options(java.lang.Class<T> c)
              throws UniformInterfaceException,
                     ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the OPTIONS method.

  Specified by:
    `options` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `c` - the type of the returned response.
  Returns:
    an instance of type `c`.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `c` is not the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### options

    public <T> T options(GenericType<T> gt)
              throws UniformInterfaceException,
                     ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the OPTIONS method.

  Specified by:
    `options` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `gt` - the generic type of the returned response.
  Returns:
    an instance of type represented by the generic type.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `gt` does not represent the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### get

    public <T> T get(java.lang.Class<T> c)
          throws UniformInterfaceException,
                 ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the GET method.

  Specified by:
    `get` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `c` - the type of the returned response.
  Returns:
    an instance of type `c`.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `c` is not the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### get

    public <T> T get(GenericType<T> gt)
          throws UniformInterfaceException,
                 ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the GET method.

  Specified by:
    `get` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `gt` - the generic type of the returned response.
  Returns:
    an instance of type represented by the generic type.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `gt` does not represent the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### put

    public void put()
             throws UniformInterfaceException,
                    ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the PUT method with no request entity or response.

  If the status code is less than 300 and a representation is present then that representation is ignored.

  Specified by:
    `put` in interface `UniformInterface`
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### put

    public void put(java.lang.Object requestEntity)
             throws UniformInterfaceException,
                    ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the PUT method with a request entity but no response.

  If the status code is less than 300 and a representation is present then that representation is ignored.

  Specified by:
    `put` in interface `UniformInterface`
  Parameters:
    `requestEntity` - the request entity.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### put

    public <T> T put(java.lang.Class<T> c)
          throws UniformInterfaceException,
                 ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the PUT method with no request entity that returns a response.

  Specified by:
    `put` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `c` - the type of the returned response.
  Returns:
    an instance of type `c`.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `c` is not the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### put

    public <T> T put(GenericType<T> gt)
          throws UniformInterfaceException,
                 ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the PUT method with a request entity that returns a response.

  Specified by:
    `put` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `gt` - the generic type of the returned response.
  Returns:
    an instance of type represented by the generic type.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `gt` does not represent the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### put

    public <T> T put(java.lang.Class<T> c,
                     java.lang.Object requestEntity)
          throws UniformInterfaceException,
                 ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the PUT method with a request entity that returns a response.

  Specified by:
    `put` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `c` - the type of the returned response.
    `requestEntity` - the request entity.
  Returns:
    an instance of type `c`.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `c` is not the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### put

    public <T> T put(GenericType<T> gt,
                     java.lang.Object requestEntity)
          throws UniformInterfaceException,
                 ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the PUT method with a request entity that returns a response.

  Specified by:
    `put` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `gt` - the generic type of the returned response.
    `requestEntity` - the request entity.
  Returns:
    an instance of type represented by the generic type.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `gt` does not represent the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### post

    public void post()
              throws UniformInterfaceException,
                     ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the POST method with no request entity or response.

  If the status code is less than 300 and a representation is present then that representation is ignored.

  Specified by:
    `post` in interface `UniformInterface`
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### post

    public void post(java.lang.Object requestEntity)
              throws UniformInterfaceException,
                     ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the POST method with a request entity but no response.

  If the status code is less than 300 and a representation is present then that representation is ignored.

  Specified by:
    `post` in interface `UniformInterface`
  Parameters:
    `requestEntity` - the request entity.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### post

    public <T> T post(java.lang.Class<T> c)
           throws UniformInterfaceException,
                  ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the POST method with no request entity that returns a response.

  Specified by:
    `post` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `c` - the type of the returned response.
  Returns:
    an instance of type `c`.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `c` is not the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### post

    public <T> T post(GenericType<T> gt)
           throws UniformInterfaceException,
                  ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the POST method with a request entity that returns a response.

  Specified by:
    `post` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `gt` - the generic type of the returned response.
  Returns:
    an instance of type represented by the generic type.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `gt` does not represent the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### post

    public <T> T post(java.lang.Class<T> c,
                      java.lang.Object requestEntity)
           throws UniformInterfaceException,
                  ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the POST method with a request entity that returns a response.

  Specified by:
    `post` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `c` - the type of the returned response.
    `requestEntity` - the request entity.
  Returns:
    an instance of type `c`.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `c` is not the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### post

    public <T> T post(GenericType<T> gt,
                      java.lang.Object requestEntity)
           throws UniformInterfaceException,
                  ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the POST method with a request entity that returns a response.

  Specified by:
    `post` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `gt` - the generic type of the returned response.
    `requestEntity` - the request entity.
  Returns:
    an instance of type represented by the generic type.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `gt` does not represent the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### delete

    public void delete()
                throws UniformInterfaceException,
                       ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the DELETE method with no request entity or response.

  If the status code is less than 300 and a representation is present then that representation is ignored.

  Specified by:
    `delete` in interface `UniformInterface`
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### delete

    public void delete(java.lang.Object requestEntity)
                throws UniformInterfaceException,
                       ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the DELETE method with a request entity but no response.

  If the status code is less than 300 and a representation is present then that representation is ignored.

  Specified by:
    `delete` in interface `UniformInterface`
  Parameters:
    `requestEntity` - the request entity.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### delete

    public <T> T delete(java.lang.Class<T> c)
             throws UniformInterfaceException,
                    ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the DELETE method with no request entity that returns a response.

  Specified by:
    `delete` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `c` - the type of the returned response.
  Returns:
    an instance of type `c`.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `c` is not the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### delete

    public <T> T delete(GenericType<T> gt)
             throws UniformInterfaceException,
                    ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the DELETE method with a request entity that returns a response.

  Specified by:
    `delete` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `gt` - the generic type of the returned response.
  Returns:
    an instance of type represented by the generic type.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `gt` does not represent the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### delete

    public <T> T delete(java.lang.Class<T> c,
                        java.lang.Object requestEntity)
             throws UniformInterfaceException,
                    ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the DELETE method with a request entity that returns a response.

  Specified by:
    `delete` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `c` - the type of the returned response.
    `requestEntity` - the request entity.
  Returns:
    an instance of type `c`.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `c` is not the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### delete

    public <T> T delete(GenericType<T> gt,
                        java.lang.Object requestEntity)
             throws UniformInterfaceException,
                    ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke the DELETE method with a request entity that returns a response.

  Specified by:
    `delete` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `gt` - the generic type of the returned response.
    `requestEntity` - the request entity.
  Returns:
    an instance of type represented by the generic type.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `gt` does not represent the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### method

    public void method(java.lang.String method)
                throws UniformInterfaceException,
                       ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke a HTTP method with no request entity or response.

  If the status code is less than 300 and a representation is present then that representation is ignored.

  Specified by:
    `method` in interface `UniformInterface`
  Parameters:
    `method` - the HTTP method.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### method

    public void method(java.lang.String method,
                       java.lang.Object requestEntity)
                throws UniformInterfaceException,
                       ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke a HTTP method with a request entity but no response.

  If the status code is less than 300 and a representation is present then that representation is ignored.

  Specified by:
    `method` in interface `UniformInterface`
  Parameters:
    `method` - the HTTP method.
    `requestEntity` - the request entity.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### method

    public <T> T method(java.lang.String method,
                        java.lang.Class<T> c)
             throws UniformInterfaceException,
                    ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke a HTTP method with no request entity that returns a response.

  Specified by:
    `method` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `method` - the HTTP method.
    `c` - the type of the returned response.
  Returns:
    an instance of type `c`.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `c` is not the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### method

    public <T> T method(java.lang.String method,
                        GenericType<T> gt)
             throws UniformInterfaceException,
                    ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke a HTTP method with no request entity that returns a response.

  Specified by:
    `method` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `method` - the HTTP method.
    `gt` - the generic type of the returned response.
  Returns:
    an instance of type represented by the generic type.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `gt` does not represent the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### method

    public <T> T method(java.lang.String method,
                        java.lang.Class<T> c,
                        java.lang.Object requestEntity)
             throws UniformInterfaceException,
                    ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke a HTTP method with a request entity that returns a response.

  Specified by:
    `method` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `method` - the HTTP method.
    `c` - the type of the returned response.
    `requestEntity` - the request entity.
  Returns:
    an instance of type `c`.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `c` is not the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### method

    public <T> T method(java.lang.String method,
                        GenericType<T> gt,
                        java.lang.Object requestEntity)
             throws UniformInterfaceException,
                    ClientHandlerException

  Description copied from interface: `UniformInterface`
  Invoke a HTTP method with a request entity that returns a response.

  Specified by:
    `method` in interface `UniformInterface`
  Type Parameters:
    `T` - the type of the response.
  Parameters:
    `method` - the HTTP method.
    `gt` - the generic type of the returned response.
    `requestEntity` - the request entity.
  Returns:
    an instance of type represented by the generic type.
  Throws:
    `UniformInterfaceException` - if the status of the HTTP response is greater than or equal to 300 and `gt` does not represent the type `ClientResponse`.
    `ClientHandlerException` - if the client handler fails to process the request or response.

### entity

    public WebResource.Builder entity(java.lang.Object entity)

  Description copied from interface: `RequestBuilder`
  Set the request entity.

  Any Java type instance for a request entity, that is supported by the client configuration of the client, can be passed. If generic information is required then an instance of `GenericEntity` may be used.

  Specified by:
    `entity` in interface `RequestBuilder<WebResource.Builder>`
  Parameters:
    `entity` - the request entity
  Returns:
    the builder.

### entity

    public WebResource.Builder entity(java.lang.Object entity,
                                      MediaType type)

  Description copied from interface: `RequestBuilder`
  Set the request entity with its media type.

  Any Java type instance for a request entity, that is supported by the client configuration of the client, can be passed. If generic information is required then an instance of `GenericEntity` may be used.

  Specified by:
    `entity` in interface `RequestBuilder<WebResource.Builder>`
  Parameters:
    `entity` - the request entity
    `type` - the media type
  Returns:
    the builder.

### entity

    public WebResource.Builder entity(java.lang.Object entity,
                                      java.lang.String type)

  Description copied from interface: `RequestBuilder`
  Set the request entity with its media type.

  Any Java type instance for a request entity, that is supported by the client configuration of the client, can be passed. If generic information is required then an instance of `GenericEntity` may be used.

  Specified by:
    `entity` in interface `RequestBuilder<WebResource.Builder>`
  Parameters:
    `entity` - the request entity
    `type` - the media type
  Returns:
    the builder.

### type

    public WebResource.Builder type(MediaType type)

  Description copied from interface: `RequestBuilder`
  Set the media type.

  Specified by:
    `type` in interface `RequestBuilder<WebResource.Builder>`
  Parameters:
    `type` - the media type
  Returns:
    the builder.

### type

    public WebResource.Builder type(java.lang.String type)

  Description copied from interface: `RequestBuilder`
  Set the media type.

  Specified by:
    `type` in interface `RequestBuilder<WebResource.Builder>`
  Parameters:
    `type` - the media type
  Returns:
    the builder.

### accept

    public WebResource.Builder accept(MediaType... types)

  Description copied from interface: `RequestBuilder`
  Add acceptable media types.

  Specified by:
    `accept` in interface `RequestBuilder<WebResource.Builder>`
  Parameters:
    `types` - an array of the acceptable media types
  Returns:
    the builder.

### accept

    public WebResource.Builder accept(java.lang.String... types)

  Description copied from interface: `RequestBuilder`
  Add acceptable media types.

  Specified by:
    `accept` in interface `RequestBuilder<WebResource.Builder>`
  Parameters:
    `types` - an array of the acceptable media types
  Returns:
    the builder.

### acceptLanguage

    public WebResource.Builder acceptLanguage(java.util.Locale... locales)

  Description copied from interface: `RequestBuilder`
  Add acceptable languages

  Specified by:
    `acceptLanguage` in interface `RequestBuilder<WebResource.Builder>`
  Parameters:
    `locales` - an array of the acceptable languages
  Returns:
    the builder.

### acceptLanguage

    public WebResource.Builder acceptLanguage(java.lang.String... locales)

  Description copied from interface: `RequestBuilder`
  Add acceptable languages

  Specified by:
    `acceptLanguage` in interface `RequestBuilder<WebResource.Builder>`
  Parameters:
    `locales` - an array of the acceptable languages
  Returns:
    the builder.

### cookie

    public WebResource.Builder cookie(Cookie cookie)

  Description copied from interface: `RequestBuilder`
  Add a cookie to be set.

  Specified by:
    `cookie` in interface `RequestBuilder<WebResource.Builder>`
  Parameters:
    `cookie` - to be set.
  Returns:
    the builder

### header

    public WebResource.Builder header(java.lang.String name,
                                      java.lang.Object value)

  Description copied from interface: `RequestBuilder`
  Add an HTTP header and value.

  Specified by:
    `header` in interface `RequestBuilder<WebResource.Builder>`
  Parameters:
    `name` - the HTTP header name.
    `value` - the HTTP header value.
  Returns:
    the builder.

### path

    public WebResource path(java.lang.String path)

  Create a new WebResource from this web resource with an additional path added to the URI of this web resource.

  Any filters on this web resource are inherited. Removal of filters may cause undefined behaviour.

  Parameters:
    `path` - the additional path.
  Returns:
    the new web resource.

### uri

    public WebResource uri(java.net.URI uri)

  Create a new WebResource from this web resource.

  If the URI contains a path component and the path starts with a '/' then the path of this web resource URI is replaced. Otherwise the path is appended.

  If the URI contains query parameters then those query parameters will replace the query parameters (if any) of this web resource.

  Any filters on this web resource are inherited. Removal of filters may cause undefined behaviour.

  Parameters:
    `uri` - the URI.
  Returns:
    the new web resource.

### queryParam

    public WebResource queryParam(java.lang.String key,
                                  java.lang.String value)

  Create a new WebResource from this web resource with an additional query parameter added to the URI of this web resource.

  Parameters:
    `key` - the query parameter name
    `value` - the query parameter value
  Returns:
    the new web resource.

### queryParams

    public WebResource queryParams(MultivaluedMap<java.lang.String,java.lang.String> params)

  Create a new WebResource from this web resource with additional query parameters added to the URI of this web resource.

  Parameters:
    `params` - the query parameters.
  Returns:
    the new web resource.

### setProperty

    public void setProperty(java.lang.String property,
                            java.lang.Object value)

  Sets WebResource related property.

  Parameters:
    `property` - property identifier.
    `value` - value of given property.

### getProperties

    public java.util.Map<java.lang.String,java.lang.Object> getProperties()

  Gets WebResource related properties.

  Properties are inherited, so setting properties on "parent" WebResource instance, creating child (for example via WebResource.path("subpath")) will set parents properties on it. However changing child properties won't cause change in parent's properties.

  Methods entrySet(), keySet() and values() are returning read-only results (via Collection.unmodifiableMap).

  Returns:
    map containing all properties.

Copyright © 2017 Oracle Corporation. All Rights Reserved.